diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 442561d01..0a51d39b8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -13,7 +13,6 @@ import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
 import java.util.Objects;
 
 import static net.minecraft.client.render.block.model.BlockModelStandard.BLOCK_TEXTURES;
-import static net.minecraft.client.render.block.model.BlockModelStandard.OVERBRIGHT_TEXTURES;
 import static net.minecraft.client.render.block.model.BlockModelStandard.RETRO_BLOCK_TEXTURES;
 
 public final class BlockModelDispatcher
@@ -407,21 +406,16 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/permafrost"));
 
         addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_STONE)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone")
-            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone_retro")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone_active")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone_retro_active"));
         addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_BASALT)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/basalt")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/basalt_active"));
         addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_LIMESTONE)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/limestone")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/limestone_active"));
         addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_GRANITE)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/granite")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/granite_active"));
         addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_PERMAFROST)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/permafrost")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/permafrost_active"));
 
         addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_STONE)
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/stone")
@@ -436,8 +430,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelCrystallineNetherrack<>(Blocks.NETHERRACK_CRYSTALLINE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/nether_crystal/crystal_netherrack"));
 
         addDispatch(new BlockModelStandard<>(Blocks.ORE_NETHERCOAL_NETHERRACK)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/nethercoal/netherrack")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/nethercoal/netherrack_overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/nethercoal/netherrack"));
 
         addDispatch(new BlockModelStandard<>(Blocks.BLOCK_COAL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_coal"));
         addDispatch(new BlockModelStandard<>(Blocks.BLOCK_IRON)
@@ -464,8 +457,7 @@ public final class BlockModelDispatcher
             .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_diamond/bottom_retro", Side.BOTTOM)
             .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_diamond/side_retro", S_SIDES));
         addDispatch(new BlockModelStandard<>(Blocks.BLOCK_NETHER_COAL)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_nethercoal")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/block_nethercoal_overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_nethercoal"));
         addDispatch(new BlockModelStandard<>(Blocks.BLOCK_STEEL)
             .setTex(BLOCK_TEXTURES, "minecraft:block/block_steel/top", Side.TOP)
             .setTex(BLOCK_TEXTURES, "minecraft:block/block_steel/bottom", Side.BOTTOM)
@@ -501,16 +493,14 @@ public final class BlockModelDispatcher
             .setTex(BLOCK_TEXTURES, "minecraft:block/motion_sensor/idle_front", Side.SOUTH));
         addDispatch(new BlockModelVeryRotatable<>(Blocks.MOTION_SENSOR_ACTIVE)
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/motion_sensor/side")
-            .setTex(BLOCK_TEXTURES, "minecraft:block/motion_sensor/active_front", Side.SOUTH)
-            .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/motion_sensor/active_front_overlay", Side.SOUTH));
+            .setTex(BLOCK_TEXTURES, "minecraft:block/motion_sensor/active_front", Side.SOUTH));
 
         addDispatch(new BlockModelRepeater(Blocks.REPEATER_IDLE)
             .setTex(BLOCK_TEXTURES, "minecraft:block/repeater/idle_top", S_TB)
             .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_SIDES));
         addDispatch(new BlockModelRepeater(Blocks.REPEATER_ACTIVE)
             .setTex(BLOCK_TEXTURES, "minecraft:block/repeater/active_top", S_TB)
-            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_SIDES)
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/repeater/active_overlay"));
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_SIDES));
 
         addDispatch(new BlockModelPiston<>(Blocks.PISTON_BASE,
             TextureRegistry.getTexture("minecraft:block/piston/face"))
@@ -739,14 +729,12 @@ public final class BlockModelDispatcher
             .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/top", Side.TOP)
             .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/bottom", Side.BOTTOM)
             .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/front", Side.SOUTH)
-            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/side", Side.WEST, Side.EAST, Side.NORTH)
-            .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/pumpkin_redstone/front_overlay", Side.SOUTH));
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/side", Side.WEST, Side.EAST, Side.NORTH));
 
 
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack/normal"));
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_IGNEOUS)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack/igneous")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/cobbled_netherrack/igneous_overlay"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack/igneous"));
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack/mossy"));
         addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/netherrack"));
         addDispatch(new BlockModelStandard<>(Blocks.BRICK_NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_netherrack"));
@@ -816,14 +804,11 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelMatcher<>(Blocks.MATCHER, false)
             .setTex(BLOCK_TEXTURES, "minecraft:block/matcher/side", S_SIDES)
-            .setTex(BLOCK_TEXTURES, "minecraft:block/matcher/front0", S_TB)
-            .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/matcher/front_overlay0", S_TB));
+            .setTex(BLOCK_TEXTURES, "minecraft:block/matcher/front0", S_TB));
 
         addDispatch(new BlockModelMatcher<>(Blocks.MATCHER_ACTIVE, true)
             .setTex(BLOCK_TEXTURES, "minecraft:block/matcher/side_active", S_SIDES)
-            .setTex(BLOCK_TEXTURES, "minecraft:block/matcher/front0", S_TB)
-            .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/matcher/front_active_overlay0", S_TB)
-            .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/matcher/side_active_overlay", S_SIDES));
+            .setTex(BLOCK_TEXTURES, "minecraft:block/matcher/front0", S_TB));
     }
 }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index 0405aa8ff..0e2e77a25 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
@@ -17,30 +17,14 @@ public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard
         super(block);
     }
 
-    public void setBrightness(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, float sideBrightness) {
-        tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
-        tessellator.setColorOpaque3f(sideBrightness, sideBrightness, sideBrightness);
-    }
-
     @Override
-    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         tessellator.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
         tessellator.setColorOpaque3f(1.0f, 1.0f, 1.0f);
 
         AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
         TilePos queryPos = new TilePos();
 
-        float sideBottom = 1.0f;
-        float sideTop = 1.0f;
-        float sideNorthSouth = 1.0f;
-        float sideEastWest = 1.0f;
-        if (ENABLE_DIRECTIONAL_LIGHTING) {
-            sideBottom = 0.5f;
-            sideTop = 1.0f;
-            sideNorthSouth = 0.8f;
-            sideEastWest = 0.6f;
-        }
-
         boolean aboveIsDoor = Block.hasLogicClass(worldSource.getBlock(tilePos.up(queryPos)), BlockLogicDoor.class);
         boolean belowIsDoor = Block.hasLogicClass(worldSource.getBlock(tilePos.down(queryPos)), BlockLogicDoor.class);
 
@@ -48,55 +32,33 @@ public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard
 
         // Bottom
         if (!belowIsDoor) {
-            setBrightness(tessellator, worldSource, tilePos.down(queryPos), sideBottom);
             renderBlocks.renderBottomFace(tessellator, bounds, tilePos, getBlockTexture(worldSource, tilePos, Side.BOTTOM));
         }
 
         // Top
         if (!aboveIsDoor) {
-            setBrightness(tessellator, worldSource, tilePos.up(queryPos), sideTop);
             renderBlocks.renderTopFace(tessellator, bounds, tilePos, getBlockTexture(worldSource, tilePos, Side.TOP));
         }
 
         // North
-        if (bounds.minZ() > FULL_CUBE_THRESHOLD) {
-            setBrightness(tessellator, worldSource, tilePos, sideNorthSouth);
-        } else {
-            setBrightness(tessellator, worldSource, tilePos.north(queryPos), sideNorthSouth);
-        }
         renderBlocks.flipTexture = shouldFlipTexture(Side.NORTH, meta);
         IconCoordinate texture = getBlockTexture(worldSource, tilePos, Side.NORTH);
         renderBlocks.renderNorthFace(tessellator, bounds, tilePos, texture);
         renderBlocks.flipTexture = false;
 
         // South
-        if (bounds.maxZ() < 1.0f - FULL_CUBE_THRESHOLD) {
-            setBrightness(tessellator, worldSource, tilePos, sideNorthSouth);
-        } else {
-            setBrightness(tessellator, worldSource, tilePos.south(queryPos), sideNorthSouth);
-        }
         renderBlocks.flipTexture = shouldFlipTexture(Side.SOUTH, meta);
         texture = getBlockTexture(worldSource, tilePos, Side.SOUTH);
         renderBlocks.renderSouthFace(tessellator, bounds, tilePos, texture);
         renderBlocks.flipTexture = false;
 
         // West
-        if (bounds.minX() > FULL_CUBE_THRESHOLD) {
-            setBrightness(tessellator, worldSource, tilePos, sideEastWest);
-        } else {
-            setBrightness(tessellator, worldSource, tilePos.west(queryPos), sideEastWest);
-        }
         renderBlocks.flipTexture = shouldFlipTexture(Side.WEST, meta);
         texture = getBlockTexture(worldSource, tilePos, Side.WEST);
         renderBlocks.renderWestFace(tessellator, bounds, tilePos, texture);
         renderBlocks.flipTexture = false;
 
         // East
-        if (bounds.maxX() < 1.0f - FULL_CUBE_THRESHOLD) {
-            setBrightness(tessellator, worldSource, tilePos, sideEastWest);
-        } else {
-            setBrightness(tessellator, worldSource, tilePos.east(queryPos), sideEastWest);
-        }
         renderBlocks.flipTexture = shouldFlipTexture(Side.EAST, meta);
         texture = getBlockTexture(worldSource, tilePos, Side.EAST);
         renderBlocks.renderEastFace(tessellator, bounds, tilePos, texture);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
index a8264f99d..c15c7c70e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -17,7 +16,7 @@ public class BlockModelEmpty<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(final @NotNull TessellatorTerrain tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(final @NotNull TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return false;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 27005cdf9..4393cbb2e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.util.helper.Side;
@@ -24,7 +23,7 @@ public class BlockModelFence<T extends BlockLogicFence> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final float f = 0.375F;
         final float f1 = 0.625F;
         AABBd bounds = new AABBd(f, 0.0F, f, f1, 1.0F, f1);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
index 0db20ff71..32255f8bc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFenceGate;
 import net.minecraft.core.util.helper.Side;
@@ -23,7 +22,7 @@ public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockMod
     }
 
     @Override
-    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBd bounds = new AABBd(this.block.getBounds());
         boolean flag = true;
         int meta = worldSource.getBlockData(tilePos);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index 2f1010beb..be38e6e85 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
@@ -35,23 +34,13 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
     }
 
     @Override
-    public boolean render(@NotNull TessellatorTerrain t, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorGeneral t, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
         t.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
         t.setColorOpaque3f(brightness, brightness, brightness);
 
         TilePos queryPos = new TilePos();
 
-        float cBottom = 1.0f;
-        float cTop = 1.0f;
-        float cNorthSouth = 1.0f;
-        float cEastWest = 1.0f;
-        if (ENABLE_DIRECTIONAL_LIGHTING) {
-            cBottom = 0.5f;
-            cTop = 1.0f;
-            cNorthSouth = 0.8f;
-            cEastWest = 0.6f;
-        }
         BlockLogicFenceThin thin = this.block.getLogic();
         boolean connectNorth = thin.canConnectTo(worldSource, tilePos, Side.NORTH);
         boolean connectSouth = thin.canConnectTo(worldSource, tilePos, Side.SOUTH);
@@ -118,23 +107,25 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxZ = tilePos.z() + ((16 / 2f) + (2 / 2f)) / 16f;
 
             // Render sides
-            t.setColorOpaque3f(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
+            t.setNormal(0, 0, -1);
             t.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMinU, sidesMinV);
 
+            t.setNormal(0, 0, 1);
             t.addVertexWithUV(minX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, maxZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(minX, maxY, maxZ, sidesMinU, sidesMinV);
 
-            t.setColorOpaque3f(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
+            t.setNormal(1, 0, 0);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(maxX, maxY, maxZ, sidesMinU, sidesMinV);
 
+            t.setNormal(-1, 0, 0);
             t.addVertexWithUV(minX, minY, minZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, minY, maxZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, maxZ, sidesMaxU, sidesMinV);
@@ -146,14 +137,14 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             double topBottomMaxV = this.columnTexIndex.getSubIconV(onePix * 2);
 
             // Render top
-            t.setColorOpaque3f(cTop * brightness, cTop * brightness, cTop * brightness);
+            t.setNormal(0, 1, 0);
             t.addVertexWithUV(minX, maxY, maxZ, topBottomMinU, topBottomMaxV);
             t.addVertexWithUV(maxX, maxY, maxZ, topBottomMaxU, topBottomMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, topBottomMaxU, topBottomMinV);
             t.addVertexWithUV(minX, maxY, minZ, topBottomMinU, topBottomMinV);
 
             // Render bottom
-            t.setColorOpaque3f(cBottom * brightness, cBottom * brightness, cBottom * brightness);
+            t.setNormal(0, -1, 0);
             t.addVertexWithUV(minX, minY, minZ, topBottomMinU, topBottomMinV);
             t.addVertexWithUV(maxX, minY, minZ, topBottomMaxU, topBottomMinV);
             t.addVertexWithUV(maxX, minY, maxZ, topBottomMaxU, topBottomMaxV);
@@ -190,12 +181,13 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + (8f / 16f);
 
-            t.setColorOpaque3f(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
+            t.setNormal(1, 0, 0);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(maxX, maxY, maxZ, sidesMinU, sidesMinV);
 
+            t.setNormal(-1, 0, 0);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, maxZ, sidesMinU, sidesMinV);
@@ -232,12 +224,13 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + 1.0f;
 
-            t.setColorOpaque3f(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
+            t.setNormal(1, 0, 0);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(maxX, maxY, maxZ, sidesMinU, sidesMinV);
 
+            t.setNormal(-1, 0, 0);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, maxZ, sidesMinU, sidesMinV);
@@ -274,12 +267,13 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + (8f / 16f);
 
-            t.setColorOpaque3f(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
+            t.setNormal(0, 0, -1);
             t.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMinU, sidesMinV);
 
+            t.setNormal(0, 0, 1);
             t.addVertexWithUV(minX, minY, maxZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, maxZ, sidesMinU, sidesMinV);
@@ -316,12 +310,13 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + (8f / 16f);
 
-            t.setColorOpaque3f(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
+            t.setNormal(0, 0, -1);
             t.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMinU, sidesMinV);
 
+            t.setNormal(0, 0, 1);
             t.addVertexWithUV(minX, minY, maxZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, maxZ, sidesMinU, sidesMinV);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 058d5f2b3..ebf152822 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.Block;
@@ -27,7 +27,7 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockData(tilePos));
         if (renderBlocks.overrideBlockTexture != null) {
             tex = renderBlocks.overrideBlockTexture;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index ecd4a7058..4247cd617 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFluid;
@@ -22,7 +22,7 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
         float r = (float) (color >> 16 & 0xff) / 255F;
         float g = (float) (color >> 8 & 0xff) / 255F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index 03e3e9ba9..878664f2f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -19,7 +18,7 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final int meta = worldSource.getBlockData(tilePos);
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(meta);
 
